#
#     26 Oct 96   for da adopted from charissa version
#    8 jan 98   modified for use with F2VB module


set frametitle "MIDAS Data Acquisition System Control (RISING)"

set CAMACPresent 0
set VMEPresent 1
set VXIPresent 1

set TSPresent 1
set RISING 1

set CAMACEnable 0
set VMEEnable 1
set VXIEnable 1

set RDOUTEnable 1

set histEnable 1
set HistMode 1

set txEnable 1

set MaxTries 100

set TitrisPresent 1


proc create_spectra {} {
    global SpectrumServer

    set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 8192 :name 'Stat' !new)" } m]
    set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 8192 :name 'Rate' !new)" } m]
    set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 65536 :name 'Time' !new)" } m]

#     all other spectra created by the VXI software histogram interface
    map_spectra
}

proc map_spectra {} {
   global EGreport RDOUThdwre

   set EGreport_SAVE $EGreport
   set EGreport -1

   set l [spectra-names]
   foreach item $l {
       set name [second $item]
       if {"$name" == "Rate"} continue
       map_spectrum $name
   }

   write-register $RDOUThdwre.Cspectramapped 1

   set EGreport $EGreport_SAVE

   set-footer "mapped [llength $l] spectra"
}

proc map_needed {} {
    global RDOUThdwre
    write-register $RDOUThdwre.Cspectramapped 0
}

proc map_spectrum {s} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 10 "Mapping spectrum $s" "$s"
}


proc click-txenable  {v} {
    global RDOUThdwre RDOUTEnable txEnable TSPresent
    if {$RDOUTEnable == 0} then {set txEnable 0} else {set txEnable $v}
    if {$TSPresent == 0 || [read-register TS_Server] == ""} then {
        set txEnable 0
    } else {
        if {$RDOUTEnable != 0} then {write-register $RDOUThdwre.Ctxenable $txEnable}
    }
    redisplay-mbs
    redisplay-txenable
}

proc redisplay-txenable {} {
   global RDOUThdwre RDOUTEnable txEnable  TSPresent
   if {$TSPresent == 0} then {return}
   if {$RDOUTEnable == 0} then {:modify TXENABLE :value 0; return}

   set txEnable [read-register $RDOUThdwre.Ctxenable]
   :modify TXENABLE :value $txEnable
   starttask stats
   :modify TXRATE :value [expr [inform stats read-Rate 5] /1024]
}

proc redisplay-rdout {} {
   global RDOUThdwre RDOUTEnable
   if {$RDOUTEnable == 0} then {:modify RDOUT :value -1; return}
   set state [read-register $RDOUThdwre.Sstate]
   :modify RDOUT :value [expr $state -1]
   starttask stats
   set rate1 [inform stats read-Rate 2]
   :modify EVENTRATE :value $rate1
   set rate2 [inform stats read-Rate 12]
   :modify TRIGRATE :value [expr $rate1 + $rate2]
}

proc redisplay-mbs {} {

    :modify TSSERVER    :value [read-register TS_Server]
    :modify TSPORT      :value [read-register TS_Port]

    click-special 20
    set s [read-register EXEC.Parameter]
    if {$s == 0} then {:modify TXACTIVE :value 0} else {:modify TXACTIVE :value 1}
}

proc do_tsdefine {} {
    click-special 3
    click-special 20
    set s [read-register EXEC.Parameter]
    if {$s == 0} then {midas-warning "Connection to MBS failed"}
    redisplay-mbs
    redisplay-txenable
    if {$s != 0} then {click-txenable 1}
}

proc do_tsundefine {}   {click-special 1; redisplay-mbs; redisplay-txenable}

proc Check-DA {} {
   global OS RDOUThdwre Alive

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

#    this check only works if GOING

   if {$OS == "VxWorks"} then {return}

   set z [catch {read-register $RDOUThdwre.Sstate} state]
   if {$z != 0} then {after 15000 Check-DA; return}
   if {$state != 2} then {return}

   set-footer "Checking Data Acqusition Program"

   set z [catch {read-register $RDOUThdwre.CAlive} Alive]
   if {$z != 0} then {after 15000 Check-DA; return}

   set z [catch {write-register $RDOUThdwre.CAlive 0}]
   if {$z != 0} then {after 15000 Check-DA; return}

   if {$Alive == 0} then {
#        midas-warning "Warning - Check the Data Acquisition Program - It may have crashed"
         set-footer "Warning - No data being received or the DA Program has crashed"
   } else {
         set-footer "Data Acquisition running OK"
   }

   click-redisplay

#   clear-footer
   after 15000 Check-DA
}
