#  titris.defn.tcl

proc {Add_TITRIS_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]

   set CurrentVMEServer  $server
 
   set A32addrbase [third $addressinfo]
   define-vme-register $name xVME Status                "-a$A32addrbase -w32 -o0x00 -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME CableDelay            "-a$A32addrbase -w32 -o0x00 -pro -d32 -l8 -b0 -zd"
   define-vme-register $name xVME Control               "-a$A32addrbase -w32 -o0x04 -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME Control.GO            "-a$A32addrbase -w32 -o0x04 -prw -d32 -l1 -b1 -zd"
   define-vme-register $name xVME Control.HALT          "-a$A32addrbase -w32 -o0x04 -pwo -d32 -l1 -b5 -zd"
   define-vme-register $name xVME Control.MASTER        "-a$A32addrbase -w32 -o0x04 -prw -d32 -l1 -b2 -zd"
   define-vme-register $name xVME Control.SLAVE         "-a$A32addrbase -w32 -o0x04 -pwo -d32 -l1 -b5 -zd"
   define-vme-register $name xVME Control.RESET         "-a$A32addrbase -w32 -o0x04 -pro -d32 -l1 -b6 -zd"
   define-vme-register $name xVME Control.ADJ           "-a$A32addrbase -w32 -o0x04 -prw -d32 -l1 -b7 -zd"
   define-vme-register $name xVME Data.LW               "-a$A32addrbase -w32 -o0x08 -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME Data.MW               "-a$A32addrbase -w32 -o0x0c -prw -d32 -l0 -b0 -zx"
   define-vme-register $name xVME Data.HW               "-a$A32addrbase -w32 -o0x10 -prw -d32 -l0 -b0 -zx"
}


proc {TITRIS_DAQ-reset} {args} {
#   TITRIS
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]

#      read the module status - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.Status] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {TITRIS_DAQ-setup} {args} {
#   TITRIS
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]

    if {[read-vme-register $module.Control.GO] != 0} {return}

#    module is not currently in the GO state - needs to be setup

    inform titris start
    inform titris calibrate_all
}

proc {TITRIS_DAQ-halt} {args} {}
proc {TITRIS_DAQ-go} {args} {}
